
////////////////////////////////////////////////////////////
//	Event handler
////////////////////////////////////////////////////////////
function OnThunderContextMenu(event)
{
	var strThunderPath = getThunderPath();
	if (isFileExists(strThunderPath))
	{
		if (gContextMenu.onLink || gContextMenu.onImage)
		{
            if (-1 == gContextMenu.link.toString().indexOf("javascript:"))
			{
				document.getElementById("ThunderDownload_1").setAttribute("hidden", false);
			}
			else if (gContextMenu.onImage)
			{
				document.getElementById("ThunderDownload_1").setAttribute("hidden", false);
			}
			else
			{
				document.getElementById("ThunderDownload_1").setAttribute("hidden", true);
			}
		}
		else
		{
			document.getElementById("ThunderDownload_1").setAttribute("hidden", true);
		}
		
		document.getElementById("ThunderDownload_All").setAttribute("hidden", false);
		document.getElementById("ThunderDownload_Up").setAttribute("hidden", false);
	}
	else
	{
		document.getElementById("ThunderDownload_1").setAttribute("hidden", true);
		document.getElementById("ThunderDownload_All").setAttribute("hidden", true);
		
		document.getElementById("ThunderDownload_Up").setAttribute("hidden", true);	
	}	
}

function OnThunderDownload(event)
{	
        if (!gContextMenu.onLink && !gContextMenu.onImage)
	{
		return;
	}
	// Get current page URL
	var strUrls = document.commandDispatcher.focusedWindow.document.URL;
        strUrls = strUrls.concat(g_strSplitter);
	// Write link count
	strUrls = strUrls.concat(1, g_strSplitter);
	// Get current link URL
	if (gContextMenu.onLink && (-1 == gContextMenu.link.toString().indexOf("javascript:")))
	{
                strUrls = strUrls.concat(gContextMenu.link.toString(), g_strSplitter);
		strUrls = strUrls.concat(gContextMenu.target.textContent.replace(/\0/g, ""), g_strSplitter);
		g_uri.spec = gContextMenu.link.toString();
	}
	else
	{
		strUrls = strUrls.concat(gContextMenu.target.src, g_strSplitter);
                strUrls = strUrls.concat(gContextMenu.target.textContent.replace(/\0/g, ""), g_strSplitter);
		g_uri.spec = gContextMenu.target.src;
	}
	
	var strCookie = g_cookieService.getCookieString(g_uri, null);
	if (strCookie == null)
	{
		strCookie = "null";
	}
	strUrls = strUrls.concat(strCookie, g_strSplitter);
	// Call thunder
	callThunder(strUrls,"1",0,0);
}

function OnThunderDownloadAll(event)
{
	// Get current page URL
	var strUrls = document.commandDispatcher.focusedWindow.document.URL;
	strUrls = strUrls.concat(g_strSplitter);
	
	// Get all links and all image count
	var links = document.commandDispatcher.focusedWindow.document.links;
	var images = document.commandDispatcher.focusedWindow.document.images;
	var link_count = links.length;
	var image_count = images.length;
	
	// Write all count
	var all_count = link_count + image_count;
	var strTemp = "";
	
	for (var i=0; i<link_count; i++)
	{
		if (-1 != links[i].href.indexOf("javascript:"))
		{
			--all_count;
			continue;
		}
	
		// Get link URL
		strTemp = strTemp.concat(links[i].href, g_strSplitter);
		
		// Get link text
		strTemp = strTemp.concat(links[i].textContent.replace(/\0/g, ""), g_strSplitter);
		
		g_uri.spec = links[i].href;
		var strCookie = g_cookieService.getCookieString(g_uri, null);
		if (strCookie == null)
		{
			strCookie = "null";
		}
		strTemp = strTemp.concat(strCookie, g_strSplitter);
	}
	
	for (i=0; i<image_count; i++)
	{
		// Get image SRC
		strTemp = strTemp.concat(images[i].src, g_strSplitter);
		
		// Get image text
		strTemp = strTemp.concat(images[i].textContent.replace(/\0/g, ""), g_strSplitter);
		
		g_uri.spec = images[i].src;
		var strCookie = g_cookieService.getCookieString(g_uri, null);
		if (strCookie == null)
		{
			strCookie = "null";
		}
		strTemp = strTemp.concat(strCookie, g_strSplitter);
	}

	strUrls = strUrls.concat(all_count, g_strSplitter);
	strUrls = strUrls.concat(strTemp);
	// Call thunder
	callThunder(strUrls, "1",0,1);
}


function getElementOuterHTML(element)
{
	if(element.nodeType != 1)
		return null;
		
	var strOuterHTML = "<" + element.nodeName;
	for(var i=0; i<element.attributes.length; i++)
	{
		if(element.attributes[i].value != null)
		{
			strOuterHTML += " ";
			strOuterHTML += element.attributes[i].name;
			strOuterHTML += "=\"";
			strOuterHTML += element.attributes[i].value;
			strOuterHTML += "\"";
		}
	}
	strOuterHTML += ">"
	strOuterHTML += element.innerHTML;
	strOuterHTML += "</" + element.nodeName + ">";
	return strOuterHTML;
}

function OnElementMouseOver(event)
{
	if(event == null)
		return false;
	if(event.target == null)
		return false;
	
	if(event.target.tagName == "A" ||
	   event.target.tagName == "B" ||
	   event.target.tagName == "FONT")
	{
		var theElement = event.target;
		do
		{
			if(theElement.tagName == "A")
			{
				var strDocumentUrl = document.commandDispatcher.focusedWindow.document.URL;
				var strOuterHTML = getElementOuterHTML(theElement);
				
				//g_thunderComponent.ShowFloatBar(strDocumentUrl, strOuterHTML);
				var thunderComponent = new ThunderComponent();
				thunderComponent.LoadDll();
				var nResult = thunderComponent.ShowFloatBar(strDocumentUrl, strOuterHTML);
				thunderComponent.UnLoadDll();
				
				break;
			}
			theElement = theElement.parentNode;
		}
		while(theElement != null);
	}
	else if(event.target.tagName == "EMBED" ||
			event.target.tagName == "OBJECT")
	{
		var strDocumentUrl = document.commandDispatcher.focusedWindow.document.URL;
		var strOuterHTML = getElementOuterHTML(event.target);
		
		//g_thunderComponent.ShowFloatBar(strDocumentUrl, strOuterHTML);
		var thunderComponent = new ThunderComponent();
		thunderComponent.LoadDll();
		var nResult = thunderComponent.ShowFloatBar(strDocumentUrl, strOuterHTML);
		thunderComponent.UnLoadDll();
	}
	else
	{
		//g_thunderComponent.HideFloatBar();
		var thunderComponent = new ThunderComponent();
		thunderComponent.LoadDll();
		var nResult = thunderComponent.HideFloatBar();
		thunderComponent.UnLoadDll();
	}
    return true;
}


function SetEventHandler(parentWindow)
{
	var elements = parentWindow.document.getElementsByTagName("*");
	for(var i=0; i<elements.length; i++)
	{
		if(elements[i].tagName != "IFRAME" &&
		   elements[i].tagName != "FRAME")
		{
			elements[i].onmouseover = OnElementMouseOver;
		}
	}
	
	var theFrames = parentWindow.frames;
	for(i=0; i<theFrames.length; i++)
	{
		SetEventHandler(theFrames[i]);
	}
}


function SetEventHandlerWrapper(parentWindow)
{
	var elements = parentWindow.document.getElementsByTagName("*");
	for(var i=0; i<elements.length; i++)
	{
		if(elements[i].tagName != "IFRAME" &&
		   elements[i].tagName != "FRAME")
		{
			//alert(elements[i].setAttributeNS);
		}
	}
	
	var theFrames = parentWindow.frames;
	for(i=0; i<theFrames.length; i++)
	{
		SetEventHandlerWrapper(theFrames[i]);
	}
}


function OnWindowLoad(event)
{
	// create thunder component
	//createThunderComponent();

	// attach events
	if(event.originalTarget == "[object HTMLDocument]")
	{
		var theDocument = event.originalTarget;
		SetEventHandler(theDocument.defaultView);
	}
	if(event.originalTarget == "[object XPCNativeWrapper [object HTMLDocument]]")
	{
		var theDocument = event.originalTarget;
		SetEventHandlerWrapper(theDocument.defaultView);	
	}
}

window.addEventListener("load", OnWindowLoad, true);



